package com.galaxis.manatee.dao;

import com.galaxis.manatee.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunSelfSubWorkHourDO;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface ChuanyunSelfSubWorkHourDao extends GalaxisRepository<ChuanyunSelfSubWorkHourDO,String> {

    /**
     * 获取单日工时数据
     * @param userId
     * @param projectId
     * @param dayLogDate
     * @param projectType
     * @return
     */
    List<ChuanyunSelfSubWorkHourDO> findByUserIdAndProjectIdAndProjectTypeAndDayLogDate(String userId, String projectId,String projectType,LocalDateTime dayLogDate);

    /**
     * 获取单日工时数据
     * @param userId
     * @param projectId
     * @param dayLogDate
     * @param projectType
     * @param status
     * @return
     */
    List<ChuanyunSelfSubWorkHourDO> findByUserIdAndProjectIdAndProjectTypeAndDayLogDateAndStatus(String userId, String projectId,String projectType,LocalDateTime dayLogDate,String status);

    /**
     * 根据用户ID获取每日工时
     * @param userId
     * @return
     */
    List<ChuanyunSelfSubWorkHourDO> findByUserId(String userId);
}
