package com.galaxis.manatee.dao;

import com.galaxis.manatee.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunSubWorkHourDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface ChuanyunSubWorkHourDao extends GalaxisRepository<ChuanyunSubWorkHourDO,String> {

    /**
     * 获取子项目每日工时
     * @param userId
     * @return
     */
    @Query(value="SELECT " +
            "chuanyun_day_log.object_id, " +
            "SUM(chuanyun_day_log.hours_worked ) AS hours_worked, " +
            "chuanyun_day_log.sub_porject_id AS project_id, " +
            "chuanyun_day_log.project_type, " +
            "chuanyun_log.user_id, " +
            "chuanyun_log.department_name, " +
            "chuanyun_day_log.sub_project_bg AS bg, " +
            "chuanyun_log. STATUS, " +
            "chuanyun_day_log.day_log_date " +
            "FROM " +
            "chuanyun_day_log " +
            "LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id " +
            "WHERE " +
            "chuanyun_log.user_id = ? " +
            "AND chuanyun_day_log.sub_porject_id != '' && chuanyun_day_log.sub_porject_id IS NOT NULL " +
            "AND chuanyun_day_log.sub_project_bg != '' && chuanyun_day_log.sub_project_bg IS NOT NULL " +
            "AND DATEDIFF(chuanyun_day_log.day_log_date,NOW()) <= 0 " +
            "AND DATEDIFF(chuanyun_day_log.day_log_date,NOW()) > -180 " +
            "GROUP BY " +
            "chuanyun_day_log.sub_porject_id, " +
            "chuanyun_log.user_id, " +
            "chuanyun_day_log.project_type, " +
            "chuanyun_log. STATUS, " +
            "chuanyun_day_log.day_log_date",nativeQuery = true)
    List<ChuanyunSubWorkHourDO> getSubSelfWorkHour(@Param("userId") String userId);


    @Query(value="SELECT chuanyun_day_log.object_id, " +
            "            SUM(chuanyun_day_log.hours_worked) AS hours_worked, " +
            "            chuanyun_day_log.sub_porject_id AS project_id, " +
            "            chuanyun_day_log.project_type, " +
            "            chuanyun_log.user_id, " +
            "            chuanyun_day_log.sub_project_bg AS bg, " +
            "            chuanyun_log.department_name, " +
            "            chuanyun_log.status, " +
            "            chuanyun_day_log.day_log_date  " +
            "            FROM chuanyun_day_log  " +
            "            LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id  " +
            "            WHERE chuanyun_log.user_id = ? " +
            "            AND chuanyun_day_log.day_log_date =? " +
            "            AND status!=3  " +
            "            GROUP BY chuanyun_log.user_id, " +
            "            chuanyun_day_log.day_log_date",nativeQuery = true)
    ChuanyunSubWorkHourDO getSubDayWorkHour(String userId, LocalDateTime day);
}
