package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.capsule.bo.ChuanyunObject;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.CascadeType;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Transient;
import java.time.LocalDateTime;
import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunBuildProject extends BasicDO {
    //对应氚云中的项目立项
    public static final String SCHEMA_CODE = "D00178955900d6e8f104217b7ff8f7d36b34de1";

    //申请人
    @JsonProperty(value = "F0000059")
    private String proposer;

    //申请日期
    @JsonProperty(value = "F0000017")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    @DateTimeFormat(pattern = "yyyy/MM/dd HH:mm:ss")
    private LocalDateTime applicationDate;

    //申请部门
    @JsonProperty(value = "F0000060")
    private String applicationDivision;

    //立项日期
    @JsonProperty(value = "F0000061")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    @DateTimeFormat(pattern = "yyyy/MM/dd HH:mm:ss")
    private LocalDateTime setUpDate;

    //项目类型
    @JsonProperty("F0000016")
    private String projectType;

    //项目名称
    @JsonProperty(value = "F0000004")
    private String projectName;

    //项目编号
    @JsonProperty(value = "F0000003")
    private String projectCode;

    //项目分类
    @JsonProperty("F0000005")
    private String projectClassify;

    //受益部门
    @JsonProperty("F0000063")
    private String benefitingDepartment;

    //实施项目经理
    @JsonProperty("F0000120Object")
    @Transient
    private ChuanyunObject implementationManager;

    //签约公司
    @JsonProperty(value = "F0000051")
    private String signingCompany;

    //客户名称
    @JsonProperty(value = "F0000039")
    private String customerName;

    //业主名称
    @JsonProperty(value = "F0000040")
    private String nameOfOwner;

    //主要交付内容
    @JsonProperty(value = "F0000064")
    private String mainContents;

    //项目经理
    @JsonProperty(value = "F0000037Object")
    @Transient
    private ChuanyunObject projectManager;

    //项目总监
    @JsonProperty(value = "F0000007Object")
    @Transient
    private ChuanyunObject projectDirector;

    //销售负责人
    @JsonProperty(value = "F0000011Object")
    @Transient
    private ChuanyunObject SalesDirector;

    //系统免费维保期
    @JsonProperty(value = "F0000104")
    private Integer systemWarranty;

    //设备免费维保期
    @JsonProperty(value = "F0000105")
    private Integer deviceWarranty;

    //维保-交付子表
    @JsonProperty(value = "D001789F28649f6f044a4224b5c68aa821918f50")
    private List<ChuanyunMaintenanceProDO> maintenanceProList;

    //维保-周期子表
    @JsonProperty(value = "D001789F3ffb030bffbf45a78c830cd7da9d59c9")
    private List<ChuanyunMaintenanceCycleDO> maintenanceCycleList;
}
