package com.galaxis.manatee.Test;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunMemberHourDO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.util.TimeUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@Slf4j
@SpringBootTest
public class clearErrorWorkHour {

    private ChuanYunManager chuanYunManager;

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Test
    void clear() {
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            List<String> matchers = new ArrayList<>();
            matchers.add("F0000001_2,ef3e45e8-006f-4a25-8f40-d5832d6898ad");
            matchers.add("F0000002_2,be8724e2-169e-49a1-8806-bd7b3631894c");
            matchers.add("F0000003_2," + TimeUtil.formatDateTime(LocalDateTime.of(2022, 1, 15, 8, 0, 0)));
            matchers.add("F0000005_2,实施");
            var filter = Filter.instance(0, Integer.MAX_VALUE, true, "And", matchers);
            var chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunMemberHourDO.SCHEMA_CODE, filter);
            if (chuanyunFindAllResponse.getReturnData() != null) {
                List<ChuanyunMemberHourDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
                });
            }

        } catch (Exception e) {
            log.error(e.getMessage());
        }

    }
}
