package com.galaxis.manatee.Test.implCost;

import com.galaxis.manatee.capsule.dto.PageDTO;
import com.galaxis.manatee.constant.ChuanYunConstant;
import com.galaxis.manatee.dao.ChuanyunImplCostDao;
import com.galaxis.manatee.dao.ChuanyunMonthLaborCostWgDao;
import com.galaxis.manatee.dao.ChuanyunReimbursementDao;
import com.galaxis.manatee.dao.ChuanyunSelfWorkHourDao;
import com.galaxis.manatee.entity.chuanyun.data.object.*;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunLaborCostWgDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunMonthLaborCostWgDTO;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.manager.ClawFeign;
import com.galaxis.manatee.service.GroupProjectService;
import com.galaxis.manatee.service.ImplCostService;
import com.galaxis.manatee.service.WorkGroupService;
import com.galaxis.manatee.util.CollectionsUtils;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@SpringBootTest
public class WorkGroupImplCostTest {

    private WorkGroupService workGroupService;
    private GroupProjectService groupProjectService;
    private ChuanyunImplCostDao implCostDao;
    private ChuanyunReimbursementDao reimbursementDao;
    private ChuanyunSelfWorkHourDao selfWorkHourDao;
    private ChuanyunMonthLaborCostWgDao chuanyunMonthLaborCostWgDao;
    private ImplCostService implCostService;
    private ChuanYunManager chuanyunManager;
    private ClawFeign clawFeign;

    @Autowired
    public void setWorkGroupService(WorkGroupService workGroupService, GroupProjectService groupProjectService, ChuanyunImplCostDao implCostDao, ChuanyunReimbursementDao reimbursementDao, ChuanyunSelfWorkHourDao selfWorkHourDao, ChuanyunMonthLaborCostWgDao chuanyunMonthLaborCostWgDao) {
        this.workGroupService = workGroupService;
        this.groupProjectService = groupProjectService;
        this.implCostDao = implCostDao;
        this.reimbursementDao = reimbursementDao;
        this.selfWorkHourDao = selfWorkHourDao;
        this.chuanyunMonthLaborCostWgDao = chuanyunMonthLaborCostWgDao;
    }

    @Autowired
    public void setImplCostService(ImplCostService implCostService) {
        this.implCostService = implCostService;
    }

    @Autowired
    public void setChuanyunManager(ChuanYunManager chuanyunManager) {
        this.chuanyunManager = chuanyunManager;
    }

    @Autowired
    public void setClawFeign(ClawFeign clawFeign) {
        this.clawFeign = clawFeign;
    }

    @Test
    void test1() {
        Optional<ChuanyunGroupProjectDO> chuanyunGroupProjectDOOptional = groupProjectService.findByProjectCode("D22218").stream().findFirst();
        if (chuanyunGroupProjectDOOptional.isPresent()) {
            ChuanyunGroupProjectDO chuanyunGroupProjectDO = chuanyunGroupProjectDOOptional.get();

            String groupProjectObjectId = chuanyunGroupProjectDO.getObjectId();
            String groupProjectCode = chuanyunGroupProjectDO.getProjectCode();
            // 查询项目报销单
            Map<LocalDate, List<ChuanyunReimbursementDO>> reimbursementMap = new HashMap<>();
            Map<LocalDate, List<ChuanyunSelfWorkHourDO>> workHoursMap = new HashMap<>();
            Map<LocalDate, List<ChuanyunMonthLaborCostWgDTO>> laborCostMap = new HashMap<>();
            List<ChuanyunReimbursementDO> reimbursements = reimbursementDao.findAllByGroupProjectIdAndStatusIn(chuanyunGroupProjectDO.getObjectId(), List.of(1, 2));
            // 查询用户在该项目的报销单
            // 报销单按日期分组
            Map<LocalDate, List<ChuanyunReimbursementDO>> map1 = reimbursements.stream().collect(Collectors.groupingBy(chuanyunReimbursementDO -> {
                if (!Objects.isNull(chuanyunReimbursementDO.getBusinessDate())) {
                    return LocalDate.of(chuanyunReimbursementDO.getBusinessDate().getYear(), chuanyunReimbursementDO.getBusinessDate().getMonthValue(), 1);
                } else {
                    return LocalDate.of(2015, 1, 1);
                }
            }));

            map1.forEach((localDate, chuanyunReimbursementDOS) -> {
                boolean containsKey = reimbursementMap.containsKey(localDate);
                if (containsKey) {
                    // 表示已经存在该key
                    List<ChuanyunReimbursementDO> reimbursementDOList = reimbursementMap.get(localDate);
                    reimbursementDOList.addAll(chuanyunReimbursementDOS);
                    reimbursementMap.put(localDate, reimbursementDOList);
                } else {
                    reimbursementMap.put(localDate, chuanyunReimbursementDOS);
                }
            });

            List<ChuanyunSelfWorkHourDO> workHours = selfWorkHourDao.findAllByProjectIdAndStatusIn(groupProjectObjectId, List.of("1", "2"));
            Map<LocalDate, List<ChuanyunSelfWorkHourDO>> map2 = workHours.stream().collect(Collectors.groupingBy(chuanyunSelfWorkHourDO -> {
                if (!Objects.isNull(chuanyunSelfWorkHourDO.getDayLogDate())) {
                    return LocalDate.of(chuanyunSelfWorkHourDO.getDayLogDate().getYear(), chuanyunSelfWorkHourDO.getDayLogDate().getMonthValue(), 1);
                } else {
                    return LocalDate.of(2015, 1, 1);
                }
            }));
            map2.forEach((localDate, chuanyunSelfWorkHourDOS) -> {
                boolean containsKey = workHoursMap.containsKey(localDate);
                if (containsKey) {
                    // 表示已经存在该key
                    List<ChuanyunSelfWorkHourDO> selfWorkHours = workHoursMap.get(localDate);
                    selfWorkHours.addAll(chuanyunSelfWorkHourDOS);
                    workHoursMap.put(localDate, selfWorkHours);
                } else {
                    workHoursMap.put(localDate, chuanyunSelfWorkHourDOS);
                }
            });

            List<ChuanyunMonthLaborCostWgDTO> laborCostWgs = chuanyunMonthLaborCostWgDao.findAllByProjectCode(groupProjectCode);
            Map<LocalDate, List<ChuanyunMonthLaborCostWgDTO>> map3 = laborCostWgs.stream().collect(Collectors.groupingBy(chuanyunMonthLaborCostWgDTO -> {
                if (!Objects.isNull(chuanyunMonthLaborCostWgDTO.getLogDate())) {
                    return LocalDate.of(chuanyunMonthLaborCostWgDTO.getLogDate().getYear(), chuanyunMonthLaborCostWgDTO.getLogDate().getMonthValue(), 1);
                } else {
                    return LocalDate.of(2015, 1, 1);
                }

            }));
            map3.forEach((localDate, chuanyunMonthLaborCostWgDTOS) -> {
                boolean containsKey = laborCostMap.containsKey(localDate);
                if (containsKey) {
                    // 表示已经存在该key
                    List<ChuanyunMonthLaborCostWgDTO> monthLaborCostWgs = laborCostMap.get(localDate);
                    monthLaborCostWgs.addAll(chuanyunMonthLaborCostWgDTOS);
                    laborCostMap.put(localDate, monthLaborCostWgs);
                } else {
                    laborCostMap.put(localDate, chuanyunMonthLaborCostWgDTOS);
                }
            });

            Set<LocalDate> localDates1 = reimbursementMap.keySet();
            Set<LocalDate> localDates2 = workHoursMap.keySet();
            Set<LocalDate> localDates3 = laborCostMap.keySet();

            Set<LocalDate> collections = CollectionsUtils.mergeCollections(localDates1, localDates2);
            Set<LocalDate> mergeCollections = CollectionsUtils.mergeCollections(collections, localDates3);

            mergeCollections.forEach(localDate -> {
                List<ChuanyunReimbursementDO> reimbursementList = reimbursementMap.getOrDefault(localDate, Collections.emptyList());
                List<ChuanyunSelfWorkHourDO> selfWorkHourList = workHoursMap.getOrDefault(localDate, Collections.emptyList());
                List<ChuanyunMonthLaborCostWgDTO> laborCostWgList = laborCostMap.getOrDefault(localDate, Collections.emptyList());

                Map<String, List<ChuanyunReimbursementDO>> workGroupIdReimbursementMap = reimbursementList.stream().collect(Collectors.groupingBy(chuanyunReimbursementDO -> {
                    if (Objects.isNull(chuanyunReimbursementDO.getWorkGroupId()) || !StringUtils.hasLength(chuanyunReimbursementDO.getWorkGroupId())) {
                        return ChuanYunConstant.DEFAULT_WORK_GROUP;
                    } else {
                        return chuanyunReimbursementDO.getWorkGroupId();
                    }
                }));
                Map<String, List<ChuanyunSelfWorkHourDO>> workGroupIdSelfWorkHourMap = selfWorkHourList.stream().collect(Collectors.groupingBy(chuanyunSelfWorkHourDO -> {
                    if (Objects.isNull(chuanyunSelfWorkHourDO.getWorkGroupId()) || !StringUtils.hasLength(chuanyunSelfWorkHourDO.getWorkGroupId())) {
                        return ChuanYunConstant.DEFAULT_WORK_GROUP;
                    } else {
                        return chuanyunSelfWorkHourDO.getWorkGroupId();
                    }
                }));
                Map<String, List<ChuanyunMonthLaborCostWgDTO>> workGroupIdLaborCostMap = laborCostWgList.stream().collect(Collectors.groupingBy(chuanyunMonthLaborCostWgDTO -> {
                    if (Objects.isNull(chuanyunMonthLaborCostWgDTO.getWorkGroupId()) || !StringUtils.hasLength(chuanyunMonthLaborCostWgDTO.getWorkGroupId())) {
                        return ChuanYunConstant.DEFAULT_WORK_GROUP;
                    } else {
                        return chuanyunMonthLaborCostWgDTO.getWorkGroupId();
                    }
                }));

                Set<String> workGroup1 = workGroupIdReimbursementMap.keySet();
                Set<String> workGroup2 = workGroupIdSelfWorkHourMap.keySet();
                Set<String> workGroup3 = workGroupIdLaborCostMap.keySet();


                Set<String> workGroupMergeCollections = CollectionsUtils.mergeStringCollections(workGroup1, workGroup2, workGroup3);
                workGroupMergeCollections.add(ChuanYunConstant.DEFAULT_WORK_GROUP);

                workGroupMergeCollections.forEach(workGroupId -> {
                    List<ChuanyunReimbursementDO> reimbursementDOList = workGroupIdReimbursementMap.getOrDefault(workGroupId, Collections.emptyList());
                    List<ChuanyunSelfWorkHourDO> selfWorkHourDOS = workGroupIdSelfWorkHourMap.getOrDefault(workGroupId, Collections.emptyList());
                    List<ChuanyunMonthLaborCostWgDTO> monthLaborCostWgDTOS = workGroupIdLaborCostMap.getOrDefault(workGroupId, Collections.emptyList());

                    BigDecimal totalReimbursement;
                    BigDecimal totalManDay;
                    BigDecimal totalLaborCost;

                    if (reimbursementDOList.isEmpty()) {
                        totalReimbursement = new BigDecimal("0.00");
                    } else {
                        totalReimbursement = reimbursementDOList.stream().map(ChuanyunReimbursementDO::getTotalAmountNotTaxed).reduce(BigDecimal.ZERO, BigDecimal::add);
                    }

                    if (selfWorkHourDOS.isEmpty()) {
                        totalManDay = new BigDecimal("0.00");
                    } else {
                        BigDecimal totalWorkHours = selfWorkHourDOS.stream().map(ChuanyunSelfWorkHourDO::getStandardWorkHour).reduce(BigDecimal.ZERO, BigDecimal::add);
                        totalManDay = totalWorkHours.divide(BigDecimal.valueOf(8), 3, RoundingMode.UP);
                    }

                    if (monthLaborCostWgDTOS.isEmpty()) {
                        totalLaborCost = new BigDecimal("0.00");
                    } else {
                        totalLaborCost = monthLaborCostWgDTOS.stream().map(ChuanyunMonthLaborCostWgDTO::getAmount).reduce(BigDecimal.ZERO, BigDecimal::add);
                    }

                    ChuanyunImplCostDO old = implCostDao.findByProjectCodeAndWorkGroupAndLocalDate(groupProjectCode, workGroupId, localDate.atStartOfDay());
                    if (!Objects.isNull(old)) {
                        BigDecimal oldImplCost = old.getImplCost();
                        BigDecimal oldManDay = old.getManDay();
                        BigDecimal oldLaborCost = old.getLaborCost();
                        if (Objects.isNull(old.getLocalDate()) ||
                                Objects.isNull(oldImplCost) ||
                                Objects.isNull(oldManDay) ||
                                Objects.isNull(oldLaborCost) ||
                                oldImplCost.compareTo(totalReimbursement) != 0 ||
                                oldManDay.compareTo(totalManDay) != 0 || oldLaborCost.compareTo(totalLaborCost) != 0) {
                            old.setImplCost(totalReimbursement);
                            old.setManDay(totalManDay);
                            old.setLaborCost(totalLaborCost);
                            implCostDao.saveAndFlush(old);
                        }
                    } else {
                        String defaultWorkGroupName = ChuanYunConstant.DEFAULT_WORK_GROUP_NAME;
                        ChuanyunWorkGroupDO workGroupDO = workGroupService.findByObjectId(workGroupId);
                        if (!Objects.isNull(workGroupDO)) {
                            defaultWorkGroupName = workGroupDO.getWorkGroupName();
                        } else {
                            ChuanyunHistoryWorkGroupDO historyWorkGroupDO = workGroupService.findInHistoryByObjectId(workGroupId);
                            if (!Objects.isNull(historyWorkGroupDO)) {
                                defaultWorkGroupName = historyWorkGroupDO.getWorkGroupName();
                            }
                        }
                        ChuanyunImplCostDO chuanyunImplCostDO = new ChuanyunImplCostDO();
                        chuanyunImplCostDO.setProjectId(chuanyunGroupProjectDO.getObjectId());
                        chuanyunImplCostDO.setProjectCode(groupProjectCode);
                        chuanyunImplCostDO.setLocalDate(localDate.atStartOfDay());
                        chuanyunImplCostDO.setWorkGroup(workGroupId);
                        chuanyunImplCostDO.setWorkGroupName(defaultWorkGroupName);
                        chuanyunImplCostDO.setImplCost(totalReimbursement);
                        chuanyunImplCostDO.setManDay(totalManDay);
                        chuanyunImplCostDO.setLaborCost(totalLaborCost);
                        implCostDao.saveAndFlush(chuanyunImplCostDO);
                    }

                });
            });
        }
    }


    @Test
    void test2() {
        List<ChuanyunImplCostDO> all = implCostService.findAllInChuanyun();
        all.forEach(chuanyunImplCostDO -> {
            chuanyunManager.delete(ChuanyunImplCostDO.SCHEMA_CODE, chuanyunImplCostDO.getObjectId());
            log.info("删除: {}", chuanyunImplCostDO);
        });

    }

    @Test
    void test3() {
        ChuanyunImplCostDO old = implCostDao.findByProjectCodeAndWorkGroupAndLocalDate("D19411-1", "defaultWorkgroup", LocalDate.of(2022, 7, 1).atStartOfDay());
        System.out.println(old);


    }

    @Test
    void test4() {
        log.info("开始保存项目工作组人力成本");
        var page = 352;
        var size = 100;
        var flag = true;
        while (flag) {
            Map<String, String> map = new HashMap<>(2);
            map.put("page", String.valueOf(page));
            map.put("size", String.valueOf(size));
            //获取物料成本
            PageDTO<ChuanyunLaborCostWgDTO> pageInfo = clawFeign.findChuanyunLaborCostWg(map);
            if (page <= pageInfo.getTotalPages()) {
                page += 1;
            } else {
                flag = false;
                break;
            }
            List<ChuanyunLaborCostWgDTO> list = pageInfo.getContent();
            list.forEach(laborCostWgDTO -> {
                if (!Objects.isNull(laborCostWgDTO)) {
                    // 保存至数据库
                    // 查询数据库比较数据
                    String projectCode = laborCostWgDTO.getChuanyunLaborCostWgPrimaryKey().getProjectcode();
                    if (Objects.equals(projectCode, "D22218")) {
                        System.out.println(laborCostWgDTO);
                    }
                }

            });
        }


    }

    @Test
    void test5() {
        log.info("开始保存项目工作组人力成本");
        var page = 37;
        var size = 1000;
        var flag = true;
        while (flag) {
            Map<String, String> map = new HashMap<>(1);
            map.put("page", String.valueOf(page));
            map.put("size", String.valueOf(size));
            //获取物料成本
            PageDTO<ChuanyunLaborCostWgDTO> pageInfo = clawFeign.findChuanyunLaborCostWg(map);
            if (page <= pageInfo.getTotalPages()) {
                page += 1;
            } else {
                flag = false;
                break;
            }
            List<ChuanyunLaborCostWgDTO> list = pageInfo.getContent();
            list.forEach(laborCostWgDTO -> {
                if (!Objects.isNull(laborCostWgDTO)) {
                    // 保存至数据库
                    // 查询数据库比较数据
                    String projectCode = laborCostWgDTO.getChuanyunLaborCostWgPrimaryKey().getProjectcode();
                    if (projectCode.equals("D22218")) {
                        log.info("...");
                    }
                    LocalDateTime time = laborCostWgDTO.getChuanyunLaborCostWgPrimaryKey().getPeriod();
                    String department = laborCostWgDTO.getChuanyunLaborCostWgPrimaryKey().getDepartment();
                    String workGroupId = laborCostWgDTO.getChuanyunLaborCostWgPrimaryKey().getWorkgroupid();
                    List<ChuanyunMonthLaborCostWgDTO> laborCostWg = chuanyunMonthLaborCostWgDao.findAllByProjectCodeAndLogDateAndWorkGroupIdAndDepartment(projectCode, time, workGroupId, department);

                    if (laborCostWg.isEmpty()) {
                        //新增
                        log.info("{},{},{},{},{}", laborCostWgDTO, projectCode, time, workGroupId, department);
                    } else {
                        if (laborCostWg.size() > 1) {
                            chuanyunMonthLaborCostWgDao.deleteAll(laborCostWg);
                            //新增
                            log.info("{},{},{},{},{}", laborCostWgDTO, projectCode, time, workGroupId, department);
                        } else if (laborCostWg.size() == 1) {
                            Optional<ChuanyunMonthLaborCostWgDTO> first = laborCostWg.stream().findFirst();
                            ChuanyunMonthLaborCostWgDTO chuanyunMonthLaborCostWgDTO = first.get();
                            BigDecimal amount = chuanyunMonthLaborCostWgDTO.getAmount();
                            BigDecimal costAmount = laborCostWgDTO.getCostamount();
                            if (amount.compareTo(costAmount) != 0) {
                                chuanyunMonthLaborCostWgDTO.setAmount(amount);
                                log.info("人力成本发生变化，更新人力成本: {}", chuanyunMonthLaborCostWgDTO);
                            }
                        }
                    }
                }

            });
        }


    }

    @Test
    void test6() {
        Map<String,String> map=new HashMap<>(1);
        map.put("workgroupid_eq","f2049d31-155f-4405-89db-495949bb47a0");
        PageDTO<ChuanyunLaborCostWgDTO> chuanyunLaborCostWg = clawFeign.findChuanyunLaborCostWg(map);
        List<ChuanyunLaborCostWgDTO> content = chuanyunLaborCostWg.getContent();
        content.forEach(System.out::println);

    }


}