package com.galaxis.manatee.Test.project;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.dao.ChuanyunGroupProjectDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.task.ChuanyunBasicDataScheduledTask;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@SpringBootTest
public class GroupProjectTest {

    private ChuanYunManager chuanYunManager;
    private ChuanyunGroupProjectDao chuanyunGroupProjectDao;
    private ChuanyunBasicDataScheduledTask basicDataScheduledTask;

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Autowired
    public void setChuanyunGroupProjectDao(ChuanyunGroupProjectDao chuanyunGroupProjectDao) {
        this.chuanyunGroupProjectDao = chuanyunGroupProjectDao;
    }

    @Autowired
    public void setBasicDataScheduledTask(ChuanyunBasicDataScheduledTask basicDataScheduledTask) {
        this.basicDataScheduledTask = basicDataScheduledTask;
    }

    @Test
    void test1() {
        ObjectMapper objectMapper = new ObjectMapper();
        List<String> m = List.of("F0000002_2,D22460");
        //从氚云查询数据
        var filter = Filter.instance(0, 10, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        //转化为POJO
        List<ChuanyunGroupProjectDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
        });
        //保存
        result.forEach(chuanyunGroupProjectDO -> {

        });
    }

    @Test
    void syncGroupProject(){
        basicDataScheduledTask.getGroupProjectManually();
    }
}
