package com.galaxis.manatee.Test.workHour;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.dao.ChuanyunGroupProjectDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunMemberHourDO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.LogService;
import com.galaxis.manatee.service.LogStandardService;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Slf4j
@SpringBootTest
public class fixBug {

    private LogService logService;

    private LogStandardService logStandardService;

    private ChuanYunManager chuanYunManager;

    private ChuanyunGroupProjectDao groupProjectDao;

    @Autowired
    public void setLogService(LogService logService) {
        this.logService = logService;
    }

    @Autowired
    public void setLogStandardService(LogStandardService logStandardService) {
        this.logStandardService = logStandardService;
    }

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Autowired
    public void setGroupProjectDao(ChuanyunGroupProjectDao groupProjectDao) {
        this.groupProjectDao = groupProjectDao;
    }

    @Test
    void fix() {
        List<String> userIdList = List.of(
                "27f10a28-e3b2-4381-bb50-6dfe94143a37");
        for (String userId : userIdList) {
            logService.downloadLogByUserId(userId);
            log.info("下载完成 userId: {}", userId);
            logStandardService.standardSelfWorkHourByUserId(userId);
            log.info("标准化完成 userId: {}", userId);
        }


    }

    @Test
    void fixProjectCode() {

        ObjectMapper objectMapper = new ObjectMapper();
        var start = 5500;
        var totalCount = 0L;
        var pageSize = 100;
        var flag = true;

        while (flag) {
            try {
                List<String> matchers = new ArrayList<>();
                matchers.add("F0000001_2,1f48d45f-10bf-4b26-ad5a-9f0e41ad02ef");
                var filter = Filter.instance(start, start + pageSize, true, Filter.AND, matchers);
                var chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunMemberHourDO.SCHEMA_CODE, filter);
                if (chuanyunFindAllResponse.getReturnData() == null) {
                    flag = false;
                    continue;
                }
                if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                    start += pageSize;
                } else {
                    flag = false;
                }
                if (chuanyunFindAllResponse.getReturnData() != null) {
                    List<ChuanyunMemberHourDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
                    });
                    result.forEach(chuanyunMemberHourDO -> {
                        if (chuanyunMemberHourDO.getStandardWorkHour().compareTo(new BigDecimal(0)) != 0 && !StringUtils.hasLength(chuanyunMemberHourDO.getProjectCode())) {
                            ChuanyunGroupProjectDO groupProjectDO = groupProjectDao.findByObjectId(chuanyunMemberHourDO.getProjectId());
                            MemberWorkHourDTO memberWorkHourDTO = new MemberWorkHourDTO();
                            memberWorkHourDTO.setProjectCode(groupProjectDO.getProjectCode());
                            String s = null;
                            try {
                                s = objectMapper.writeValueAsString(memberWorkHourDTO);
                                chuanYunManager.update(ChuanyunMemberHourDO.SCHEMA_CODE, s, chuanyunMemberHourDO.getObjectId());
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
                }


            } catch (Exception e) {
                log.warn("更新标准工时异常");
            }
        }

        log.info("更新完成");
    }

    @Data
    static class MemberWorkHourDTO {

        @JsonProperty("F0000011")
        private String projectCode;
    }
}
