package com.galaxis.manatee.Test.zzx;

import com.galaxis.manatee.entity.chuanyun.data.object.Handbook;
import com.galaxis.manatee.entity.chuanyun.data.object.MyExcelData;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.*;
import java.lang.reflect.Field;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

@Slf4j
@SpringBootTest
/**
 * 分权手册(h2人员信息)更新
 */
public class ProjectTest2 {
    public static void main(String[] args) {
        List<List<Object>> excel1 = getExcel("C:\\Users\\86186\\Desktop\\分权手册2022_09_22_14_18_14.xlsx");
        List<List<Object>> excel2 = getExcel("C:\\Users\\86186\\Desktop\\凯捷--2022年度分级授权手册20220921.xls");

        // 最新的h2分权手册
        List<MyExcelData> excelDataList = new ArrayList<>();
        for (int j = 0; j < excel2.size(); j++) {
            List<Object> newH2 = excel2.get(j);
            if (j > 1) {
                // System.err.println(newH2);
                // System.err.println("newH2[1]：" + newH2.get(1));
                // splitArr数组:6-一级领导,7-二级领导,8-三级领导,9-总经理,10-集团分管领导
                MyExcelData myExcelData = new MyExcelData();
                myExcelData.setName(newH2.get(1).toString());
                myExcelData.setCompany(newH2.get(2).toString());
                myExcelData.setFirstName(newH2.get(6).toString());
                myExcelData.setSecondName(newH2.get(7).toString());
                myExcelData.setThirdName(newH2.get(8).toString());
                myExcelData.setManager(newH2.get(9).toString());
                myExcelData.setGroupChargeLeader(newH2.get(10).toString());
                excelDataList.add(myExcelData);
            }
        }
        // System.err.println(excelDataList.toString());

        // 集团所有人的信息
        List<Handbook> handbookList = new ArrayList<>();
        for (int i = 0; i < excel1.size(); i++) {
            List<Object> objects1 = excel1.get(i);
            if (i > 1) {
                // System.err.println(objects1.toString());
                // splitArr数组:9-一级领导,10-二级领导,11-三级领导,13-分公司总经理,14-集团分管领导
                Handbook handbook = new Handbook();
                handbook.setObjectId(objects1.get(0).toString());
                handbook.setName(objects1.get(1).toString());
                handbook.setOwnerId(objects1.get(3).toString());
                handbook.setOwnerDeptId(objects1.get(4).toString());
                handbook.setF0000001(objects1.get(7).toString());

                for (int k = 0; k < excelDataList.size(); k++) {
                    MyExcelData myExcelData = excelDataList.get(k);
                    // System.err.println("handbook.getName()：" + handbook.getName() + "，myExcelData.getName()：" + myExcelData.getName());
                    if (handbook.getName().equals(myExcelData.getName())) {
                        // System.err.println(myExcelData.toString());
                        handbook.setF0000003(myExcelData.getFirstName());
                        handbook.setF0000004(myExcelData.getSecondName());
                        handbook.setF0000005(myExcelData.getThirdName());
                        handbook.setF0000006(myExcelData.getManager());
                        handbook.setF0000007(myExcelData.getGroupChargeLeader());
                        handbook.setF0000012(myExcelData.getCompany());
                    }
                }

                if (handbook.getF0000003() == null) handbook.setF0000003(objects1.get(9).toString());
                if (handbook.getF0000004() == null) handbook.setF0000004(objects1.get(10).toString());
                if (handbook.getF0000005() == null) handbook.setF0000005(objects1.get(11).toString());
                if (handbook.getF0000006() == null) handbook.setF0000006(objects1.get(13).toString());
                if (handbook.getF0000007() == null) handbook.setF0000007(objects1.get(14).toString());
                if (handbook.getF0000012() == null) {
                    if (objects1.size() == 19)
                        handbook.setF0000012(objects1.get(18).toString());
                    else
                        handbook.setF0000012("");
                }

                handbook.setCreatedBy(objects1.get(2).toString());
                handbook.setCreatedTime(objects1.get(5).toString());
                handbook.setModifiedTime(objects1.get(6).toString());
                handbook.setF0000002(objects1.get(8).toString());
                handbook.setF0000011(objects1.get(12).toString());
                handbook.setF0000009(objects1.get(15).toString());
                handbook.setF0000008(objects1.get(16).toString());
                handbook.setF0000010(objects1.get(17).toString());

                handbookList.add(handbook);
            }
        }

        // System.err.println(handbookList.toString());
        // System.err.println(handbookList.get(609));  //刘东升

        // toTxt(handbookList);
        toExcel(handbookList);
    }

    //将List导出成Excel
    public static void toExcel(List<Handbook> handbookList) {
        //创建一个Excel文件
        HSSFWorkbook workbook = new HSSFWorkbook();

        //创建一个sheet
        HSSFSheet sheet = workbook.createSheet("更新过后的分权手册");

        //在sheet表中添加0行
        HSSFRow row = sheet.createRow(0);

        //创建单元格，设置表头
        HSSFCell cell = row.createCell(0);
        cell.setCellValue("ObjectId");

        cell = row.createCell(1);
        cell.setCellValue("Name");

        cell = row.createCell(2);
        cell.setCellValue("CreatedBy");

        cell = row.createCell(3);
        cell.setCellValue("OwnerId");

        cell = row.createCell(4);
        cell.setCellValue("OwnerDeptId");

        cell = row.createCell(5);
        cell.setCellValue("CreatedTime");

        cell = row.createCell(6);
        cell.setCellValue("ModifiedTime");

        cell = row.createCell(7);
        cell.setCellValue("F0000001");

        cell = row.createCell(8);
        cell.setCellValue("F0000002");

        cell = row.createCell(9);
        cell.setCellValue("F0000003");

        cell = row.createCell(10);
        cell.setCellValue("F0000004");

        cell = row.createCell(11);
        cell.setCellValue("F0000005");

        cell = row.createCell(12);
        cell.setCellValue("F0000011");

        cell = row.createCell(13);
        cell.setCellValue("F0000006");

        cell = row.createCell(14);
        cell.setCellValue("F0000007");

        cell = row.createCell(15);
        cell.setCellValue("F0000009");

        cell = row.createCell(16);
        cell.setCellValue("F0000008");

        cell = row.createCell(17);
        cell.setCellValue("F0000010");

        cell = row.createCell(18);
        cell.setCellValue("F0000012");

        for (int i = 0; i < handbookList.size(); i++) {
            //创建行
            HSSFRow row1 = sheet.createRow(i + 1);
            Handbook handbook = handbookList.get(i);

            //为单元格写入值，从0开始
            row1.createCell(0).setCellValue(handbook.getObjectId());
            row1.createCell(1).setCellValue(handbook.getName());
            row1.createCell(2).setCellValue(handbook.getCreatedBy());
            row1.createCell(3).setCellValue(handbook.getOwnerId());
            row1.createCell(4).setCellValue(handbook.getOwnerDeptId());
            row1.createCell(5).setCellValue(handbook.getCreatedTime());
            row1.createCell(6).setCellValue(handbook.getModifiedTime());
            row1.createCell(7).setCellValue(handbook.getF0000001());
            row1.createCell(8).setCellValue(handbook.getF0000002());
            row1.createCell(9).setCellValue(handbook.getF0000003());
            row1.createCell(10).setCellValue(handbook.getF0000004());
            row1.createCell(11).setCellValue(handbook.getF0000005());
            row1.createCell(12).setCellValue(handbook.getF0000011());
            row1.createCell(13).setCellValue(handbook.getF0000006());
            row1.createCell(14).setCellValue(handbook.getF0000007());
            row1.createCell(15).setCellValue(handbook.getF0000009());
            row1.createCell(16).setCellValue(handbook.getF0000008());
            row1.createCell(17).setCellValue(handbook.getF0000010());
            row1.createCell(18).setCellValue(handbook.getF0000012());
        }

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("YYYYMMddHHmmss");
        File file = new File("C:/Users/86186/Desktop/更新过后的分权手册" + simpleDateFormat.format(new Date()) + ".xls");
        if (file.exists()) {
            file.delete();
        }

        //将文件保存到指定的位置
        try {
            file.createNewFile();
            FileOutputStream outputStream = FileUtils.openOutputStream(file);
            workbook.write(outputStream);
            System.out.println("导出到桌面成功");
            workbook.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    //将List导出成Txt
    public static void toTxt(List<Handbook> handbookList) {
        BufferedWriter bw;
        try {
            bw = new BufferedWriter(new FileWriter("C:/Users/86186/Desktop/test.txt"));
            for (int j = 0; j < handbookList.size(); j++) {
                bw.write(handbookList.get(j).toString());
                bw.newLine();
                bw.flush();
            }
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static List<List<Object>> getExcel(String filePath) {
        Workbook wb = null;
        Sheet sheet = null;
        Row row = null;
        wb = readExcel(filePath);

        List<List<List<Object>>> list = new ArrayList<>();
        if (wb != null) {
            try {
                // 循环页签
                for (int sheetNum = 0; sheetNum < wb.getNumberOfSheets(); sheetNum++) {
                    // 指定页签的值
                    sheet = wb.getSheetAt(sheetNum);
                    // 定义存放一个页签中所有数据的List
                    List<List<Object>> sheetList = new ArrayList<>();
                    // 循环行
                    for (int rowNum = 0; rowNum <= sheet.getLastRowNum(); rowNum++) {
                        // 指定行的值
                        row = sheet.getRow(rowNum);
                        // 定义存放一行数据的List
                        List<Object> rowList = new ArrayList<>();
                        // 循环列
                        if (row != null) {
                            for (int cellNum = 0; cellNum < row.getLastCellNum(); cellNum++) {
                                Cell cell = sheet.getRow(rowNum).getCell(cellNum);
                                rowList.add(getStringCellValue(cell));
                            }
                        }
                        sheetList.add(rowList);
                    }
                    list.add(sheetList);
                }
                // System.err.println(list.get(0).size());
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list.get(0);
    }

    //判断文件格式
    public static Workbook readExcel(String filePath) {
        if (filePath == null) {
            return null;
        }
        String extString = filePath.substring(filePath.lastIndexOf("."));
        try {
            InputStream is = new FileInputStream(filePath);
            if (".xls".equals(extString)) {
                return new HSSFWorkbook(is);
            } else if (".xlsx".equals(extString)) {
                return new XSSFWorkbook(is);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String getStringCellValue(Cell cell) {
        String cellvalue = "";
        if (cell == null) {
            return "";
        }
        switch (cell.getCellType()) {
            case Cell.CELL_TYPE_STRING:
                cellvalue = cell.getStringCellValue();
                break;
            case Cell.CELL_TYPE_NUMERIC:
                if (DateUtil.isCellDateFormatted(cell)) {
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    Date date = cell.getDateCellValue();
                    cellvalue = sdf.format(date);
                } else {
                    cellvalue = String.valueOf(cell.getNumericCellValue());
                }
                break;
            case Cell.CELL_TYPE_BOOLEAN:
                cellvalue = String.valueOf(cell.getBooleanCellValue());
                break;
            case Cell.CELL_TYPE_BLANK:
                cellvalue = "";
                break;
            default:
                cellvalue = "";
                break;
        }
        if (cellvalue == "") {
            return "";
        }
        return cellvalue;
    }

    //判断对象中属性值是否全为空
    public static boolean checkObjAllFieldsIsNull(Object object) {
        if (null == object) return true;

        try {
            for (Field f : object.getClass().getDeclaredFields()) {
                f.setAccessible(true);
                // System.out.print(f.getName() + ":");
                // System.out.println(f.get(object));
                if (f.get(object) != null && StringUtils.isNotBlank(f.get(object).toString())) {
                    return false;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return true;
    }
}